diff --git a/m4/ax_python_devel.m4 b/m4/ax_python_devel.m4
new file mode 100644
index 0000000..f18ed8a
--- /dev/null
+++ b/m4/ax_python_devel.m4
@@ -0,0 +1,327 @@
+# ===========================================================================
+#      http://www.gnu.org/software/autoconf-archive/ax_python_devel.html
+# ===========================================================================
+#
+# SYNOPSIS
+#
+#   AX_PYTHON_DEVEL([version])
+#
+# DESCRIPTION
+#
+#   Note: Defines as a precious variable "PYTHON_VERSION". Don't override it
+#   in your configure.ac.
+#
+#   This macro checks for Python and tries to get the include path to
+#   'Python.h'. It provides the $(PYTHON_CPPFLAGS) and $(PYTHON_LIBS) output
+#   variables. It also exports $(PYTHON_EXTRA_LIBS) and
+#   $(PYTHON_EXTRA_LDFLAGS) for embedding Python in your code.
+#
+#   You can search for some particular version of Python by passing a
+#   parameter to this macro, for example ">= '2.3.1'", or "== '2.4'". Please
+#   note that you *have* to pass also an operator along with the version to
+#   match, and pay special attention to the single quotes surrounding the
+#   version number. Don't use "PYTHON_VERSION" for this: that environment
+#   variable is declared as precious and thus reserved for the end-user.
+#
+#   This macro should work for all versions of Python >= 2.1.0. As an end
+#   user, you can disable the check for the python version by setting the
+#   PYTHON_NOVERSIONCHECK environment variable to something else than the
+#   empty string.
+#
+#   If you need to use this macro for an older Python version, please
+#   contact the authors. We're always open for feedback.
+#
+# LICENSE
+#
+#   Copyright (c) 2009 Sebastian Huber <sebastian-huber@web.de>
+#   Copyright (c) 2009 Alan W. Irwin
+#   Copyright (c) 2009 Rafael Laboissiere <rafael@laboissiere.net>
+#   Copyright (c) 2009 Andrew Collier
+#   Copyright (c) 2009 Matteo Settenvini <matteo@member.fsf.org>
+#   Copyright (c) 2009 Horst Knorr <hk_classes@knoda.org>
+#   Copyright (c) 2013 Daniel Mullner <muellner@math.stanford.edu>
+#
+#   This program is free software: you can redistribute it and/or modify it
+#   under the terms of the GNU General Public License as published by the
+#   Free Software Foundation, either version 3 of the License, or (at your
+#   option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+#   Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License along
+#   with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+#   As a special exception, the respective Autoconf Macro's copyright owner
+#   gives unlimited permission to copy, distribute and modify the configure
+#   scripts that are the output of Autoconf when processing the Macro. You
+#   need not follow the terms of the GNU General Public License when using
+#   or distributing such scripts, even though portions of the text of the
+#   Macro appear in them. The GNU General Public License (GPL) does govern
+#   all other use of the material that constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the Autoconf
+#   Macro released by the Autoconf Archive. When you make and distribute a
+#   modified version of the Autoconf Macro, you may extend this special
+#   exception to the GPL to apply to your modified version as well.
+
+#serial 18
+
+AU_ALIAS([AC_PYTHON_DEVEL], [AX_PYTHON_DEVEL])
+AC_DEFUN([AX_PYTHON_DEVEL],[
+	#
+	# Allow the use of a (user set) custom python version
+	#
+	AC_ARG_VAR([PYTHON_VERSION],[The installed Python
+		version to use, for example '2.3'. This string
+		will be appended to the Python interpreter
+		canonical name.])
+
+	AC_PATH_PROG([PYTHON],[python[$PYTHON_VERSION]])
+	if test -z "$PYTHON"; then
+	   AC_MSG_ERROR([Cannot find python$PYTHON_VERSION in your system path])
+	   PYTHON_VERSION=""
+	fi
+
+	#
+	# Check for a version of Python >= 2.1.0
+	#
+	AC_MSG_CHECKING([for a version of Python >= '2.1.0'])
+	ac_supports_python_ver=`$PYTHON -c "import sys; \
+		ver = sys.version.split ()[[0]]; \
+		print (ver >= '2.1.0')"`
+	if test "$ac_supports_python_ver" != "True"; then
+		if test -z "$PYTHON_NOVERSIONCHECK"; then
+			AC_MSG_RESULT([no])
+			AC_MSG_FAILURE([
+This version of the AC@&t@_PYTHON_DEVEL macro
+doesn't work properly with versions of Python before
+2.1.0. You may need to re-run configure, setting the
+variables PYTHON_CPPFLAGS, PYTHON_LIBS, PYTHON_SITE_PKG,
+PYTHON_EXTRA_LIBS and PYTHON_EXTRA_LDFLAGS by hand.
+Moreover, to disable this check, set PYTHON_NOVERSIONCHECK
+to something else than an empty string.
+])
+		else
+			AC_MSG_RESULT([skip at user request])
+		fi
+	else
+		AC_MSG_RESULT([yes])
+	fi
+
+	#
+	# if the macro parameter ``version'' is set, honour it
+	#
+	if test -n "$1"; then
+		AC_MSG_CHECKING([for a version of Python $1])
+		ac_supports_python_ver=`$PYTHON -c "import sys; \
+			ver = sys.version.split ()[[0]]; \
+			print (ver $1)"`
+		if test "$ac_supports_python_ver" = "True"; then
+		   AC_MSG_RESULT([yes])
+		else
+			AC_MSG_RESULT([no])
+			AC_MSG_ERROR([this package requires Python $1.
+If you have it installed, but it isn't the default Python
+interpreter in your system path, please pass the PYTHON_VERSION
+variable to configure. See ``configure --help'' for reference.
+])
+			PYTHON_VERSION=""
+		fi
+	fi
+
+	#
+	# Check if you have distutils, else fail
+	#
+	AC_MSG_CHECKING([for the distutils Python package])
+	ac_distutils_result=`$PYTHON -c "import distutils" 2>&1`
+	if test -z "$ac_distutils_result"; then
+		AC_MSG_RESULT([yes])
+	else
+		AC_MSG_RESULT([no])
+		AC_MSG_ERROR([cannot import Python module "distutils".
+Please check your Python installation. The error was:
+$ac_distutils_result])
+		PYTHON_VERSION=""
+	fi
+
+	#
+	# Check for Python include path
+	#
+	AC_MSG_CHECKING([for Python include path])
+	if test -z "$PYTHON_CPPFLAGS"; then
+		python_path=`$PYTHON -c "import distutils.sysconfig; \
+			print (distutils.sysconfig.get_python_inc ());"`
+		plat_python_path=`$PYTHON -c "import distutils.sysconfig; \
+			print (distutils.sysconfig.get_python_inc (plat_specific=1));"`
+		if test -n "${python_path}"; then
+			if test "${plat_python_path}" != "${python_path}"; then
+				python_path="-I$python_path -I$plat_python_path"
+			else
+				python_path="-I$python_path"
+			fi
+		fi
+		PYTHON_CPPFLAGS=$python_path
+	fi
+	AC_MSG_RESULT([$PYTHON_CPPFLAGS])
+	AC_SUBST([PYTHON_CPPFLAGS])
+
+	#
+	# Check for Python library path
+	#
+	AC_MSG_CHECKING([for Python library path])
+	if test -z "$PYTHON_LIBS"; then
+		# (makes two attempts to ensure we've got a version number
+		# from the interpreter)
+		ac_python_version=`cat<<EOD | $PYTHON -
+
+# join all versioning strings, on some systems
+# major/minor numbers could be in different list elements
+from distutils.sysconfig import *
+e = get_config_var('VERSION')
+if e is not None:
+	print(e)
+EOD`
+
+		if test -z "$ac_python_version"; then
+			if test -n "$PYTHON_VERSION"; then
+				ac_python_version=$PYTHON_VERSION
+			else
+				ac_python_version=`$PYTHON -c "import sys; \
+					print (sys.version[[:3]])"`
+			fi
+		fi
+
+		# Make the versioning information available to the compiler
+		AC_DEFINE_UNQUOTED([HAVE_PYTHON], ["$ac_python_version"],
+                                   [If available, contains the Python version number currently in use.])
+
+		# First, the library directory:
+		ac_python_libdir=`cat<<EOD | $PYTHON -
+
+# There should be only one
+import distutils.sysconfig
+e = distutils.sysconfig.get_config_var('LIBDIR')
+if e is not None:
+	print (e)
+EOD`
+
+		# Now, for the library:
+		ac_python_library=`cat<<EOD | $PYTHON -
+
+import distutils.sysconfig
+c = distutils.sysconfig.get_config_vars()
+if 'LDVERSION' in c:
+	print ('python'+c[['LDVERSION']])
+else:
+	print ('python'+c[['VERSION']])
+EOD`
+
+		# This small piece shamelessly adapted from PostgreSQL python macro;
+		# credits goes to momjian, I think. I'd like to put the right name
+		# in the credits, if someone can point me in the right direction... ?
+		#
+		if test -n "$ac_python_libdir" -a -n "$ac_python_library"
+		then
+			# use the official shared library
+			ac_python_library=`echo "$ac_python_library" | sed "s/^lib//"`
+			PYTHON_LIBS="-L$ac_python_libdir -l$ac_python_library"
+		else
+			# old way: use libpython from python_configdir
+			ac_python_libdir=`$PYTHON -c \
+			  "from distutils.sysconfig import get_python_lib as f; \
+			  import os; \
+			  print (os.path.join(f(plat_specific=1, standard_lib=1), 'config'));"`
+			PYTHON_LIBS="-L$ac_python_libdir -lpython$ac_python_version"
+		fi
+
+		if test -z "PYTHON_LIBS"; then
+			AC_MSG_ERROR([
+  Cannot determine location of your Python DSO. Please check it was installed with
+  dynamic libraries enabled, or try setting PYTHON_LIBS by hand.
+			])
+		fi
+	fi
+	AC_MSG_RESULT([$PYTHON_LIBS])
+	AC_SUBST([PYTHON_LIBS])
+
+	#
+	# Check for site packages
+	#
+	AC_MSG_CHECKING([for Python site-packages path])
+	if test -z "$PYTHON_SITE_PKG"; then
+		PYTHON_SITE_PKG=`$PYTHON -c "import distutils.sysconfig; \
+			print (distutils.sysconfig.get_python_lib(0,0));"`
+	fi
+	AC_MSG_RESULT([$PYTHON_SITE_PKG])
+	AC_SUBST([PYTHON_SITE_PKG])
+
+	#
+	# libraries which must be linked in when embedding
+	#
+	AC_MSG_CHECKING(python extra libraries)
+	if test -z "$PYTHON_EXTRA_LDFLAGS"; then
+	   PYTHON_EXTRA_LDFLAGS=`$PYTHON -c "import distutils.sysconfig; \
+                conf = distutils.sysconfig.get_config_var; \
+                print (conf('LIBS') + ' ' + conf('SYSLIBS'))"`
+	fi
+	AC_MSG_RESULT([$PYTHON_EXTRA_LDFLAGS])
+	AC_SUBST(PYTHON_EXTRA_LDFLAGS)
+
+	#
+	# linking flags needed when embedding
+	#
+	AC_MSG_CHECKING(python extra linking flags)
+	if test -z "$PYTHON_EXTRA_LIBS"; then
+		PYTHON_EXTRA_LIBS=`$PYTHON -c "import distutils.sysconfig; \
+			conf = distutils.sysconfig.get_config_var; \
+			print (conf('LINKFORSHARED'))"`
+	fi
+	AC_MSG_RESULT([$PYTHON_EXTRA_LIBS])
+	AC_SUBST(PYTHON_EXTRA_LIBS)
+
+	#
+	# final check to see if everything compiles alright
+	#
+	AC_MSG_CHECKING([consistency of all components of python development environment])
+	# save current global flags
+	ac_save_LIBS="$LIBS"
+	ac_save_LDFLAGS="$LDFLAGS"
+	ac_save_CPPFLAGS="$CPPFLAGS"
+	LIBS="$ac_save_LIBS $PYTHON_LIBS $PYTHON_EXTRA_LIBS $PYTHON_EXTRA_LIBS"
+	LDFLAGS="$ac_save_LDFLAGS $PYTHON_EXTRA_LDFLAGS"
+	CPPFLAGS="$ac_save_CPPFLAGS $PYTHON_CPPFLAGS"
+	AC_LANG_PUSH([C])
+	AC_LINK_IFELSE([
+		AC_LANG_PROGRAM([[#include <Python.h>]],
+				[[Py_Initialize();]])
+		],[pythonexists=yes],[pythonexists=no])
+	AC_LANG_POP([C])
+	# turn back to default flags
+	CPPFLAGS="$ac_save_CPPFLAGS"
+	LIBS="$ac_save_LIBS"
+	LDFLAGS="$ac_save_LDFLAGS"
+
+	AC_MSG_RESULT([$pythonexists])
+
+        if test ! "x$pythonexists" = "xyes"; then
+	   AC_MSG_FAILURE([
+  Could not link test program to Python. Maybe the main Python library has been
+  installed in some non-standard library path. If so, pass it to configure,
+  via the LIBS environment variable.
+  Example: ./configure LIBS="-L/usr/non-standard-path/python/lib"
+  ============================================================================
+   ERROR!
+   You probably have to install the development version of the Python package
+   for your distribution.  The exact name of this package varies among them.
+  ============================================================================
+	   ])
+	  PYTHON_VERSION=""
+	fi
+
+	#
+	# all done!
+	#
+])
diff --git a/sample/ipmicmd.c b/sample/ipmicmd.c
index 53ba3a0..37fb913 100644
--- a/sample/ipmicmd.c
+++ b/sample/ipmicmd.c
@@ -267,7 +267,7 @@ typedef struct timed_data_s
     ipmi_con_t     *con;
     struct timeval start_time;
     ipmi_msg_t     msg;
-    unsigned char  data[MAX_IPMI_DATA_SIZE];
+    unsigned char  data[IPMI_MAX_MSG_LENGTH];
     ipmi_addr_t    addr;
     unsigned int   addr_len;
     unsigned int   count;
@@ -368,7 +368,7 @@ process_input_line(char *buf)
     ipmi_addr_t        *addr = (ipmi_addr_t *) addr_data;
     unsigned int       addr_len;
     ipmi_msg_t         msg;
-    unsigned char      outbuf[MAX_IPMI_DATA_SIZE];
+    unsigned char      outbuf[IPMI_MAX_MSG_LENGTH];
     int                rv = 0;
     short              channel;
     unsigned char      seq = 0;
diff --git a/swig/perl/Makefile.am b/swig/perl/Makefile.am
index f83d927..b90b9d4 100644
--- a/swig/perl/Makefile.am
+++ b/swig/perl/Makefile.am
@@ -44,6 +44,8 @@ uninstall-local:
 
 AM_TESTS_ENVIRONMENT = mkdir -p tmppersist && mkdir -p auto/OpenIPMI && cp OpenIPMI.so auto/OpenIPMI && TEST_LD_PRELOAD="$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/perl/.libs/libdummystuff.so" LD_LIBRARY_PATH=$(top_builddir)/glib/.libs PERL5LIB="$(top_builddir)/swig/perl:$(srcdir)" top_builddir="$(top_builddir)" srcdir="$(srcdir)"
 TESTS = test_fru test_chan test_lanparm test_pet test_pef
+REAL_TESTS = test_fru.p test_chan.p test_lanparm.p test_pet.p test_pef.p
 
 EXTRA_DIST = OpenIPMI_perl.c OpenIPMI_lang.i OpenIPMI.h \
-	sample ipmi_powerctl $(TESTS) Lanserv.pm lan.conf dummystuff.c
+	sample ipmi_powerctl $(TESTS) $(REAL_TESTS) \
+	Lanserv.pm lan.conf dummystuff.c
diff --git a/swig/python/Makefile.am b/swig/python/Makefile.am
index da95a81..323d0b1 100644
--- a/swig/python/Makefile.am
+++ b/swig/python/Makefile.am
@@ -1,7 +1,8 @@
 
 SUBDIRS = . @PYTHON_GUI_DIR@
+DIST_SUBDIRS = openipmigui
 
-AM_CFLAGS = $(PYTHON_CFLAGS) \
+AM_CFLAGS = $(PYTHON_CPPFLAGS) \
 	    -I $(top_builddir) \
 	    -I $(top_builddir)/include \
 	    -I $(top_srcdir)/include \
@@ -9,7 +10,7 @@ AM_CFLAGS = $(PYTHON_CFLAGS) \
 	    -DPYTHON_HAS_POSIX_THREADS=@PYTHON_HAS_POSIX_THREADS@
 
 pythonlibdir=$(PYTHON_INSTALL_LIB_DIR)
-PYPATH=$(top_builddir)/swig/python:$(top_builddir)/swig/python/.libs:$(srcdir)/openipmigui
+PYPATH=$(top_builddir)/swig/python:$(top_builddir)/swig/python/.libs
 
 pythonlib_LTLIBRARIES = _OpenIPMI.la
 
@@ -19,22 +20,18 @@ _OpenIPMI_la_LIBADD = $(OPENIPMI_SWIG_LIBS) $(PYTHON_POSIX_LIB)
 
 EXTRA_DIST = OpenIPMI_lang.i OpenIPMI.h openipmigui.py sample.py sample2.py
 
-OpenIPMI.pyc: OpenIPMI.py _OpenIPMI.la
-	-PYTHONPATH=$(PYPATH) $(pythonprog) -c 'import OpenIPMI.py'
-
-OpenIPMI.pyo: OpenIPMI.py _OpenIPMI.la
-	-PYTHONPATH=$(PYPATH) $(pythonprog) -O -c 'import OpenIPMI.py'
-
 OpenIPMI_wrap.c OpenIPMI.py: $(top_srcdir)/swig/OpenIPMI.i OpenIPMI_lang.i
-	$(SWIG) $(DEFS) -python -o OpenIPMI_wrap.c -I$(top_srcdir)/swig/python $<
+	$(SWIG) $(DEFS) -python $(PYTHON_SWIG_FLAGS) -o OpenIPMI_wrap.c \
+		-I$(top_srcdir)/swig/python $<
 
 CLEANFILES = OpenIPMI_wrap.c OpenIPMI.py OpenIPMI.pyo OpenIPMI.pyc
 
-install-exec-local: _OpenIPMI.la OpenIPMI.py OpenIPMI.pyc OpenIPMI.pyo
+clean-local:
+	rm -rf __pycache__
+
+install-exec-local: _OpenIPMI.la OpenIPMI.py
 	$(INSTALL) -d $(DESTDIR)$(PYTHON_INSTALL_DIR)
 	$(INSTALL_DATA) OpenIPMI.py "$(DESTDIR)$(PYTHON_INSTALL_DIR)"
-	$(INSTALL_DATA) OpenIPMI.pyc "$(DESTDIR)$(PYTHON_INSTALL_DIR)"
-	$(INSTALL_DATA) OpenIPMI.pyo "$(DESTDIR)$(PYTHON_INSTALL_DIR)"
 	if test "x$(PYTHON_GUI_DIR)" = "xopenipmigui"; then \
 	    $(INSTALL) -d $(DESTDIR)$(bindir); \
 	    $(INSTALL_SCRIPT) $(srcdir)/openipmigui.py "$(DESTDIR)$(bindir)/openipmigui";\
@@ -43,9 +40,7 @@ install-exec-local: _OpenIPMI.la OpenIPMI.py OpenIPMI.pyc OpenIPMI.pyo
 uninstall-local:
 	$(LIBTOOL) --mode=uninstall rm -f "$(DESTDIR)$(PYTHON_INSTALL_LIB_DIR)/_OpenIPMI.so"
 	rm -f "$(DESTDIR)$(PYTHON_INSTALL_DIR)/OpenIPMI.py"
-	rm -f "$(DESTDIR)$(PYTHON_INSTALL_DIR)/OpenIPMI.pyc"
-	rm -f "$(DESTDIR)$(PYTHON_INSTALL_DIR)/OpenIPMI.pyo"
 	rm -f "$(DESTDIR)$(bindir)/openipmigui"
 
 rungui:
-	LD_LIBRARY_PATH=$(top_builddir)/glib/.libs LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(pythonprog) $(top_srcdir)/swig/python/openipmigui.py
+	LD_LIBRARY_PATH=$(top_builddir)/glib/.libs LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(PYTHON) $(top_srcdir)/swig/python/openipmigui.py
diff --git a/swig/python/openipmigui.py b/swig/python/openipmigui.py
index 9b80ca1..e874c87 100755
--- a/swig/python/openipmigui.py
+++ b/swig/python/openipmigui.py
@@ -248,7 +248,7 @@ def run(args):
     # Detect if we need a separate OpenIPMI driver thread.  See the
     # openipmi_driver function above for the reason.
     try:
-        import thread
+        import threading
         try:
             top.tk.getvar("tcl_platform", "threaded")
             # Tcl is threaded, no need for another thread.
diff --git a/swig/python/openipmigui/Makefile.am b/swig/python/openipmigui/Makefile.am
index 570e7b9..b8c66d8 100644
--- a/swig/python/openipmigui/Makefile.am
+++ b/swig/python/openipmigui/Makefile.am
@@ -1,5 +1,5 @@
 
-EXTRA_DIST = _control.py _domain.py _entity.py _mc.py _sensor.py \
+PY_FILES = _control.py _domain.py _entity.py _mc.py _sensor.py \
 	gui_domainDialog.py gui.py __init__.py _saveprefs.py _fru.py \
 	_sel.py _oi_logging.py _mc_chan.py _mc_lanparm.py _mc_user.py \
 	_conn.py gui_cmdwin.py _term.py gui_SoL.py _mc_solparm.py \
@@ -7,21 +7,9 @@ EXTRA_DIST = _control.py _domain.py _entity.py _mc.py _sensor.py \
 	gui_lightset.py gui_treelist.py gui_list.py gui_term.py \
 	_misc.py gui_winsys.py
 
-PYC_FILES = _control.pyc _domain.pyc _entity.pyc _mc.pyc _sensor.pyc \
-	gui_domainDialog.pyc gui.pyc __init__.pyc _saveprefs.pyc _fru.pyc \
-	_sel.pyc _oi_logging.pyc _mc_chan.pyc _mc_lanparm.pyc _mc_user.pyc \
-	_conn.pyc gui_cmdwin.pyc _term.pyc gui_SoL.pyc _mc_solparm.pyc \
-	_mc_pefparm.pyc gui_errstr.pyc gui_popup.pyc gui_setdialog.pyc \
-	gui_lightset.pyc gui_treelist.pyc gui_list.pyc gui_term.pyc \
-	_misc.pyc gui_winsys.pyc
-
-PYO_FILES = _control.pyo _domain.pyo _entity.pyo _mc.pyo _sensor.pyo \
-	gui_domainDialog.pyo gui.pyo __init__.pyo _saveprefs.pyo _fru.pyo \
-	_sel.pyo _oi_logging.pyo _mc_chan.pyo _mc_lanparm.pyo _mc_user.pyo \
-	_conn.pyo gui_cmdwin.pyo _term.pyo gui_SoL.pyo _mc_solparm.pyo \
-	_mc_pefparm.pyo gui_errstr.pyo gui_popup.pyo gui_setdialog.pyo \
-	gui_lightset.pyo gui_treelist.pyo gui_list.pyo gui_term.pyo \
-	_misc.pyo gui_winsys.pyo
+EXTRA_DIST = $(PY_FILES)
+
+CLEANFILES = $(PY_FILES) *.pyc *.pyo
 
 # Python doesn't have any way to output the compiled files somewhere else,
 # and it doesn't work very well for them to be remote, anyway, so maintain
@@ -34,24 +22,16 @@ localcopy:
 		fi \
 	done
 
-all-local: localcopy $(PYC_FILES) $(PYO_FILES)
+all-local: localcopy
 
-install-exec-local: $(EXTRA_DIST) $(PYC_FILES) $(PYO_FILES)
+install-exec-local: $(EXTRA_DIST)
 	$(INSTALL) -d $(DESTDIR)$(PYTHON_INSTALL_DIR)/openipmigui
 	$(INSTALL_DATA) $^ $(DESTDIR)$(PYTHON_INSTALL_DIR)/openipmigui
 
 uninstall-local:
-	(for i in $(EXTRA_DIST) $(PYC_FILES) $(PYO_FILES); do \
+	(for i in $(EXTRA_DIST); do \
 		rm -f $(DESTDIR)$(PYTHON_INSTALL_DIR)/openipmigui/$$i; \
 	done)
 	-rmdir "$(DESTDIR)$(PYTHON_INSTALL_DIR)/openipmigui"
 
 PYPATH=$(top_builddir)/swig/python:$(top_builddir)/swig/python/.libs:$(srcdir)
-
-.py.pyc:
-	LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(pythonprog) -c 'import $*'
-
-.py.pyo:
-	LD_PRELOAD=$(OPENIPMI_SWIG_SO):$(top_builddir)/swig/python/.libs/_OpenIPMI.so PYTHONPATH=$(PYPATH) $(pythonprog) -O -c 'import $*'
-
-CLEANFILES = $(PYC_FILES) $(PYO_FILES)
diff --git a/swig/python/openipmigui/_conn.py b/swig/python/openipmigui/_conn.py
index 84f7de9..e0dc9bc 100644
--- a/swig/python/openipmigui/_conn.py
+++ b/swig/python/openipmigui/_conn.py
@@ -31,8 +31,8 @@
 #
 
 import OpenIPMI
-import gui_popup
-import gui_SoL
+from openipmigui import gui_popup
+from openipmigui import gui_SoL
 
 class Port:
     def __init__(self, domain, c, pnum):
diff --git a/swig/python/openipmigui/_control.py b/swig/python/openipmigui/_control.py
index 829d1cf..2923d34 100644
--- a/swig/python/openipmigui/_control.py
+++ b/swig/python/openipmigui/_control.py
@@ -31,9 +31,9 @@
 #
 
 import OpenIPMI
-import gui_popup
-import gui_setdialog
-import gui_lightset
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
+from openipmigui import gui_lightset
 
 class ControlRefreshData:
     def __init__(self, c):
diff --git a/swig/python/openipmigui/_domain.py b/swig/python/openipmigui/_domain.py
index 21a8162..9af5b9e 100644
--- a/swig/python/openipmigui/_domain.py
+++ b/swig/python/openipmigui/_domain.py
@@ -30,16 +30,16 @@
 #  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 #
 
-import gui_popup
-import gui_setdialog
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 import OpenIPMI
-import _entity
-import _mc
-import _saveprefs
-import _sel
-import _fru
-import _conn
-import _oi_logging
+from openipmigui import _entity
+from openipmigui import _mc
+from openipmigui import _saveprefs
+from openipmigui import _sel
+from openipmigui import _fru
+from openipmigui import _conn
+from openipmigui import _oi_logging
 
 class InvalidDomainError(Exception):
     def __init__(self, value):
diff --git a/swig/python/openipmigui/_entity.py b/swig/python/openipmigui/_entity.py
index 7a1fa10..e0bc3ea 100644
--- a/swig/python/openipmigui/_entity.py
+++ b/swig/python/openipmigui/_entity.py
@@ -31,12 +31,12 @@
 #
 
 import OpenIPMI
-import _oi_logging
-import _sensor
-import _control
-import _fru
-import gui_popup
-import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import _sensor
+from openipmigui import _control
+from openipmigui import _fru
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 
 class EntityOp:
     def __init__(self, e, func):
diff --git a/swig/python/openipmigui/_fru.py b/swig/python/openipmigui/_fru.py
index 8ee020e..d87a514 100644
--- a/swig/python/openipmigui/_fru.py
+++ b/swig/python/openipmigui/_fru.py
@@ -31,10 +31,10 @@
 #
 
 import OpenIPMI
-import _oi_logging
-import gui_treelist
-import gui_popup
-import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import gui_treelist
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 
 class ReinitOnAny:
     def __init__(self, glist):
diff --git a/swig/python/openipmigui/_mc.py b/swig/python/openipmigui/_mc.py
index 93eef34..db07d6b 100644
--- a/swig/python/openipmigui/_mc.py
+++ b/swig/python/openipmigui/_mc.py
@@ -30,12 +30,12 @@
 #  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 #
 import OpenIPMI
-import gui_popup
-import gui_setdialog
-import _oi_logging
-import _sel
-import _mc_chan
-import _mc_pefparm
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import _sel
+from openipmigui import _mc_chan
+from openipmigui import _mc_pefparm
 
 class MCOpHandler:
     def __init__(self, m, func, handler=None, boolval=None):
diff --git a/swig/python/openipmigui/_mc_chan.py b/swig/python/openipmigui/_mc_chan.py
index ce25bf1..c7aab3a 100644
--- a/swig/python/openipmigui/_mc_chan.py
+++ b/swig/python/openipmigui/_mc_chan.py
@@ -31,12 +31,12 @@
 #
 
 import OpenIPMI
-import gui_popup
-import gui_treelist
-import _oi_logging
-import _mc_lanparm
-import _mc_solparm
-import _mc_user
+from openipmigui import gui_popup
+from openipmigui import gui_treelist
+from openipmigui import _oi_logging
+from openipmigui import _mc_lanparm
+from openipmigui import _mc_solparm
+from openipmigui import _mc_user
 
 # Collect all the info for the channels of an MC.  For each channel
 # all the info is requested using the types immediately below.  If the
diff --git a/swig/python/openipmigui/_mc_lanparm.py b/swig/python/openipmigui/_mc_lanparm.py
index 54f009c..e61293a 100644
--- a/swig/python/openipmigui/_mc_lanparm.py
+++ b/swig/python/openipmigui/_mc_lanparm.py
@@ -32,11 +32,11 @@
 
 import sys
 import OpenIPMI
-import _oi_logging
-import gui_errstr
-import gui_list
-import gui_popup
-import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import gui_errstr
+from openipmigui import gui_list
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 
 class MCLPData:
     def __init__(self, glist, lpc, parm, aidx, pname, ptype, origval):
diff --git a/swig/python/openipmigui/_mc_pefparm.py b/swig/python/openipmigui/_mc_pefparm.py
index 9cf71ec..596a9f1 100644
--- a/swig/python/openipmigui/_mc_pefparm.py
+++ b/swig/python/openipmigui/_mc_pefparm.py
@@ -32,11 +32,11 @@
 
 import sys
 import OpenIPMI
-import _oi_logging
-import gui_errstr
-import gui_list
-import gui_popup
-import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import gui_errstr
+from openipmigui import gui_list
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 
 class MCPEFData:
     def __init__(self, glist, pefc, parm, aidx, pname, ptype, origval):
diff --git a/swig/python/openipmigui/_mc_solparm.py b/swig/python/openipmigui/_mc_solparm.py
index e1b1fde..b16de44 100644
--- a/swig/python/openipmigui/_mc_solparm.py
+++ b/swig/python/openipmigui/_mc_solparm.py
@@ -32,11 +32,11 @@
 
 import sys
 import OpenIPMI
-import _oi_logging
-import gui_errstr
-import gui_list
-import gui_popup
-import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import gui_errstr
+from openipmigui import gui_list
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
 
 class MCSOLData:
     def __init__(self, glist, solc, parm, aidx, pname, ptype, origval):
diff --git a/swig/python/openipmigui/_mc_user.py b/swig/python/openipmigui/_mc_user.py
index c2163a3..67d725c 100644
--- a/swig/python/openipmigui/_mc_user.py
+++ b/swig/python/openipmigui/_mc_user.py
@@ -31,11 +31,11 @@
 #
 
 import OpenIPMI
-import gui_popup
-import gui_treelist
-import gui_setdialog
-import _oi_logging
-import _mc_lanparm
+from openipmigui import gui_popup
+from openipmigui import gui_treelist
+from openipmigui import gui_setdialog
+from openipmigui import _oi_logging
+from openipmigui import _mc_lanparm
 
 class BoolSetter:
     def __init__(self, mcusers, user, setter):
diff --git a/swig/python/openipmigui/_saveprefs.py b/swig/python/openipmigui/_saveprefs.py
index c033942..d749e6a 100644
--- a/swig/python/openipmigui/_saveprefs.py
+++ b/swig/python/openipmigui/_saveprefs.py
@@ -32,7 +32,7 @@
 
 import xml.dom
 import xml.dom.minidom
-import _oi_logging
+from openipmigui import _oi_logging
 import os
 import stat
 import sys
diff --git a/swig/python/openipmigui/_sel.py b/swig/python/openipmigui/_sel.py
index 5e72bb5..70ae121 100644
--- a/swig/python/openipmigui/_sel.py
+++ b/swig/python/openipmigui/_sel.py
@@ -32,9 +32,9 @@
 
 import OpenIPMI
 import sys
-import gui_list
-import gui_popup
-import _misc
+from openipmigui import gui_list
+from openipmigui import gui_popup
+from openipmigui import _misc
 
 class EventData:
     def __init__(self, slist, ev, has_second_data):
diff --git a/swig/python/openipmigui/_sensor.py b/swig/python/openipmigui/_sensor.py
index e5a5b66..3189865 100644
--- a/swig/python/openipmigui/_sensor.py
+++ b/swig/python/openipmigui/_sensor.py
@@ -30,9 +30,9 @@
 #  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 #
 import OpenIPMI
-import gui_popup
-import gui_setdialog
-import _oi_logging
+from openipmigui import gui_popup
+from openipmigui import gui_setdialog
+from openipmigui import _oi_logging
 
 class SensorRefreshData:
     def __init__(self, s):
diff --git a/swig/python/openipmigui/gui.py b/swig/python/openipmigui/gui.py
index 5321f15..64b216c 100644
--- a/swig/python/openipmigui/gui.py
+++ b/swig/python/openipmigui/gui.py
@@ -36,14 +36,14 @@ except:
     from tkinter import tix as Tix
 
 import OpenIPMI
-import _saveprefs
-import _oi_logging
-import gui_domainDialog
-import gui_errstr
-import gui_cmdwin
-import gui_list
-import gui_popup
-import gui_winsys
+from openipmigui import _saveprefs
+from openipmigui import _oi_logging
+from openipmigui import gui_domainDialog
+from openipmigui import gui_errstr
+from openipmigui import gui_cmdwin
+from openipmigui import gui_list
+from openipmigui import gui_popup
+from openipmigui import gui_winsys
 
 init_treenamewidth = 150
 init_sashposition = 400
diff --git a/swig/python/openipmigui/gui_SoL.py b/swig/python/openipmigui/gui_SoL.py
index 5cdc2c9..c4d7662 100644
--- a/swig/python/openipmigui/gui_SoL.py
+++ b/swig/python/openipmigui/gui_SoL.py
@@ -36,9 +36,9 @@ except:
     import tkinter
     from tkinter import tix as Tix
 
-import gui_setdialog
-import gui_term
-import gui_errstr
+from openipmigui import gui_setdialog
+from openipmigui import gui_term
+from openipmigui import gui_errstr
 
 # Note in this file SoL refers to the main SoL object and sol refers
 # to the connection.
diff --git a/swig/python/openipmigui/gui_cmdwin.py b/swig/python/openipmigui/gui_cmdwin.py
index b8d8ece..e05f246 100644
--- a/swig/python/openipmigui/gui_cmdwin.py
+++ b/swig/python/openipmigui/gui_cmdwin.py
@@ -39,8 +39,8 @@ except:
 import xml.dom
 import xml.dom.minidom
 import OpenIPMI
-import _saveprefs
-import _misc
+from openipmigui import _saveprefs
+from openipmigui import _misc
 import os
 import stat
 import sys
diff --git a/swig/python/openipmigui/gui_domainDialog.py b/swig/python/openipmigui/gui_domainDialog.py
index c3b27e7..8920935 100644
--- a/swig/python/openipmigui/gui_domainDialog.py
+++ b/swig/python/openipmigui/gui_domainDialog.py
@@ -36,8 +36,8 @@ except:
     from tkinter import tix as Tix
 
 import OpenIPMI
-import _domain
-import gui_errstr
+from openipmigui import _domain
+from openipmigui import gui_errstr
 
 class EnumHolder:
     def __init__(self):
diff --git a/swig/python/openipmigui/gui_list.py b/swig/python/openipmigui/gui_list.py
index ca1882a..0b229df 100644
--- a/swig/python/openipmigui/gui_list.py
+++ b/swig/python/openipmigui/gui_list.py
@@ -35,8 +35,8 @@ try:
 except:
     import tkinter
     from tkinter import tix as Tix
-import gui_errstr
-import gui_winsys
+from openipmigui import gui_errstr
+from openipmigui import gui_winsys
 
 # A list widget that can be embedded in something else
 class SubList(Tix.ScrolledHList):
diff --git a/swig/python/openipmigui/gui_setdialog.py b/swig/python/openipmigui/gui_setdialog.py
index 581cab4..6dd72ec 100644
--- a/swig/python/openipmigui/gui_setdialog.py
+++ b/swig/python/openipmigui/gui_setdialog.py
@@ -35,7 +35,7 @@ try:
 except:
     import tkinter
     from tkinter import tix as Tix
-import gui_errstr
+from openipmigui import gui_errstr
 
 def isbool(v):
     return type(v) == type(True)
diff --git a/swig/python/openipmigui/gui_term.py b/swig/python/openipmigui/gui_term.py
index 85bbec8..cdb2d87 100644
--- a/swig/python/openipmigui/gui_term.py
+++ b/swig/python/openipmigui/gui_term.py
@@ -35,7 +35,7 @@ try:
 except:
     import tkinter
     from tkinter import tix as Tix
-import _term
+from openipmigui import _term
 
 def gpos(x, y):
     return str(y+1) + "." + str(x)
diff --git a/swig/python/openipmigui/gui_treelist.py b/swig/python/openipmigui/gui_treelist.py
index 0493781..a6fc22c 100644
--- a/swig/python/openipmigui/gui_treelist.py
+++ b/swig/python/openipmigui/gui_treelist.py
@@ -35,8 +35,8 @@ try:
 except:
     import tkinter
     from tkinter import tix as Tix
-import gui_errstr
-import gui_winsys
+from openipmigui import gui_errstr
+from openipmigui import gui_winsys
 
 class TreeList(Tix.Toplevel):
     def __init__(self, name, root, columns):
